head	1.3;
access;
symbols
	Stage2:1.3;
locks; strict;
comment	@% @;


1.3
date	98.01.02.07.06.25;	author apkp;	state Exp;
branches;
next	1.2;

1.2
date	97.08.13.12.19.37;	author apkp;	state Exp;
branches;
next	1.1;

1.1
date	97.08.13.01.23.12;	author apkp;	state Exp;
branches;
next	;


desc
@@


1.3
log
@*** empty log message ***
@
text
@\documentclass[portrait,semrot]{seminar}
\scrollmode
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{epsfig}
\usepackage{sem-a4}
\usepackage{fancybox}
\usepackage{fancyheadings}
\usepackage{algorithmic}
\usepackage{float}
\usepackage{subfigure}
\newlength{\defaultparindent}
\setlength{\defaultparindent}{\parindent}
\slideframe{Oval}

\newcommand{\heading}[1]{%
  \begin{center}
    {\large \bf #1}%
  \end{center}
  \vspace{1ex minus 1ex}}

\newcommand{\subheading}[1]{%
  \begin{center}
    {\bf #1}%
  \end{center}
  \vspace{1ex minus 1ex}}
\newcommand{\subsubheading}[1]{%
  {#1}%
  \vspace{1ex minus 1ex}}

                                %\psdraft
\renewcommand{\today}{August 16, 1997}
\begin{document}
                                % Slide 0
\begin{slide*}
  \heading{Algorithms for Medical Imaging Visualization}

  \vfill
  \begin{center}
    M. Tech Project \\
    Second Stage \\
    by\\{\bf Anantha Padmanaban K Potty.}\\
    96305603\\
                                %\vspace{0.5cm}

    \vfill
    Guide : {\bf Prof. Sharat Chandran}\\ 
                                %\vspace{0.5cm}

    \vfill
    Dept.\ of Computer Science \& Engineering, \\
    Indian Institute of Technology, \\
    Bombay.\\
    \today
  \end{center}
\end{slide*}

                                % Slide 1
\begin{slide*}
  \heading{Problem}
  \begin{description}
  \item[Input] 3 dimensional raster image and a 3 dimensional vector
    representing the View Plane Normal (VPN).
  \item[Output] Rendered image of the raster when viewed along the VPN.
  \end{description}

  \subheading{Techniques}
  \begin{itemize}
  \item Back-to-Front rendering.
  \item Front-to-Back rendering.
  \item Raycasting.
  \end{itemize}
\end{slide*}

                                % Slide 2

\begin{slide*}
  \heading{Raycasting}
  \centerline{\epsfig{file=figs/surface_detect.eps,width=0.9\linewidth}}
  \begin{algorithmic}[1]
    \PROC{DetectSurface}{(image : Image, viewWindow : ViewPlane)}
    \FORALL{Pixels in viewWindow}
    \STATE Cast a ray into object space to determine the first voxel
    greater than threshold (representative criterion).
    \ENDFOR
    \ENDPROC
  \end{algorithmic}
\end{slide*}

                                % Slide 3
\begin{slide*}
  \heading{3D raycasting}
  \begin{algorithmic}[1]
    \PROC{DetectSurface}{(image : Image, viewWindow : ViewPlane)}
    \FORALL{Pixels in viewWindow}
    \STATE Digitize ray originating at pixel.
    \STATE Sequentially check at each point in the digitized ray for
    intensity greater than threshold.
    \ENDFOR
    \ENDPROC
  \end{algorithmic}
  \subheading{Drawbacks}
  \begin{enumerate}
  \item Repeated digitizations of rays.
  \item Sequential search is inherently slow.
  \end{enumerate}
\end{slide*}

                                % Slide 4
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Glassner's Approach}
  Let the ray decide the order of traversal among the voxels.
  \begin{algorithmic}[1]
    \PROC{DetectObjPoint}{(cube : ObjSpace, thresh : Intensity, ray : Line)}
    \IF{MaxIntensity in $cube < thresh$}
    \STATE \textbf{return} NoPointFound.
    \ELSIF{$Homogeneous (cube)$}
    \STATE \textbf{return} Intersection of $cube$ and $ray$.
    \ENDIF 
    \STATE get first child to traverse.
    \LOOP
    \STATE DetectObjPoint (child, $thresh$, $ray$).
    \IF{Found}
    \STATE \textbf{return} detected point.
    \ENDIF
    \STATE get next child.
    \ENDLOOP
    \ENDPROC
  \end{algorithmic}
\end{slide*}

                                % Slide 5
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Get next child}
  \begin{itemize}
  \item Find intersection of ray with child at which ray leaves it and
    add an offset to it.
  \end{itemize}
  \begin{figure}[H]
    \centerline{\mbox{\subfigure[add offset to one coord of
        $Q$]{\epsfig{file=figs/offsetadd1.eps,width=0.3\textwidth}} 
        \subfigure[add offset to two coords of
        $Q$]{\epsfig{file=figs/offsetadd2.eps,width=0.3\textwidth}}
        \subfigure[add offset to three coords of
        $Q$]{\epsfig{file=figs/offsetadd3.eps,width=0.3\textwidth}}}}
  \end{figure}
  \subheading{Drawbacks}
  \begin{itemize}
  \item Repeated intersection computations.
  \end{itemize}
\end{slide*}

                                % Slide 6
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Another ``Getting next child''}
  \begin{enumerate}
  \item digitize the ray at child resolution to get an ordering of children.
  \end{enumerate}
  \subheading{Drawbacks}
  \begin{itemize}
  \item Digitizes every ray at multiple resolutions.
  \end{itemize}
\end{slide*}

                                % Slide 7
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Discrete raycasting}
  \begin{algorithmic}[1]
    \PROC{DetectObjPoint}{(cube : ObjSpace, ray : DigitizedRay, $i$ :
      Index)}
    \STATE \COMMENT{\textbf{let} $P_i$ be the point on ray at index $i$.}
    \IF{$empty(cube)$}
    \STATE $j \leftarrow$ \textit{JumpCube} (cube, ray, i).
    \STATE \textbf{return} \textit{DetectObjPoint} ($Subcube (P_i) $, ray, $j$).
    \ENDIF
    \IF{\textit{Homogeneous} (cube)}
    \STATE \textbf{return} $P_i$.
    \ENDIF
    \STATE \textbf{return} \textit{DetectObjPoint} ($Subcube (P_i)$, ray, $i$).
    \ENDPROC
  \end{algorithmic}
\end{slide*}

                                % Slide 8
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Discrete raycasting}
  \subsubheading{Example :}
  \centerline{\epsfig{file=figs/scanconvjump.eps,width=0.9\linewidth}}
\end{slide*}

                                % Slide 9
\begin{slide*}
  \heading{Raycasting and Octree}
  \subheading{Common form of $DetectObjPoint$}
  \begin{algorithmic}[1]
    \PROC{DetectObjPoint}{(cube : ObjSpace, thresh : Intensity, ray : Line)}
    \IF{MaxIntensity in $cube < thresh$}
    \STATE \textbf{return} NoPointFound.
    \ELSIF{$Homogeneous (cube)$}
    \STATE \textbf{return} Intersection of $cube$ and $ray$.
    \ENDIF 
    \STATE firstPt $\leftarrow$ Intersection of $cube$ and $ray$.
    \REPEAT
    \STATE next $\leftarrow$ FindSubVoxel ($cube$, firstPt).
    \STATE pt $\leftarrow$ DetectObjPoint (next, $thresh$, $ray$).
    \IF{pt is valid}
    \STATE \textbf{return} pt.
    \ENDIF
    \STATE firstPt $\leftarrow$ PointInNeighbour ($cube$, next, $ray$).
    \UNTIL{($firstPt \not\in cube$)}.
    \ENDPROC
  \end{algorithmic}
\end{slide*}

                                % Slide 10
\begin{slide*}
  \heading{Differences among the Octree methods}
  \begin{itemize}
  \item Glassner's Implementation.
    \begin{description}
    \item[\textit{FindSubVoxel}] return smallest subcube containing point.
    \item[\textit{PointInNeighbour}] return offset added to exit point.
    \end{description}
  \item Vanilla Implementation.
    \begin{description}
    \item[\textit{FindSubVoxel}] return child containing point.
    \item[\textit{PointInNeighbour}] redundant.
    \end{description}
  \item Discrete Raycasting.
    \begin{description}
    \item[\textit{FindSubVoxel}] return smallest subcube containing point.
    \item[\textit{PointInNeighbour}] \textit{JumpCube}
    \end{description}
  \end{itemize}
\end{slide*}
                                % Slide 11
\begin{slide*}
  \heading{Summary}
  \begin{itemize}
  \item Raycasting.
  \item Discrete raycasting.
  \item Glassner's raycasting for octree.
  \item Vanilla implementation.
  \item Discrete raycasting for octree.
  \end{itemize}
\end{slide*}

                                % Slide 12
\begin{slide*}
  \heading{Future Work}
  \begin{itemize}
  \item Implementing the proposed algorithm.
  \item Comparison with Glassner's/Ajay Gupta's algorithms w.\,r.\,t.\ memory
    and time.
  \end{itemize}
\end{slide*}
\end{document}
@


1.2
log
@As show to sharat.
@
text
@d32 1
d41 1
a41 1
    First Stage \\
d62 2
a63 2
  \item[Input] 3 dimensional raster image and a 3 dimensional vector representing
    the View Plane Normal (VPN) and the viewing direction.
d83 2
a84 2
      \STATE Cast a ray into object space to determine the first voxel
      greater than threshold (representative criterion).
d136 13
a148 5
  \subheading{Vanilla Implementation of Glassner}
  \begin{enumerate}
  \item Getting the ``next'' child.
  \item digitize the ray at child resolution to get an ordering of children.
  \end{enumerate}
d151 1
a151 1
  \item Digitizes every ray at multiple resolutions.
d159 4
d164 1
a164 14
  \item Find intersection of ray with child at which ray leaves it and
    add an offset to it.
  \end{itemize}
  \begin{figure}[H]
    \centerline{\mbox{\subfigure[add offset to one coord of
      $Q$]{\epsfig{file=figs/offsetadd1.eps,width=0.3\textwidth}} 
      \subfigure[add offset to two coords of
      $Q$]{\epsfig{file=figs/offsetadd2.eps,width=0.3\textwidth}}
      \subfigure[add offset to three coords of
      $Q$]{\epsfig{file=figs/offsetadd3.eps,width=0.3\textwidth}}}}
  \end{figure}
\subheading{Drawbacks}
  \begin{itemize}
  \item Repeated intersection computations.
d220 1
a220 1
                                % Slide 11
d224 5
a233 5
  \item Glassner's Implementation.
    \begin{description}
    \item[\textit{FindSubVoxel}] return smallest subcube containing point.
    \item[\textit{PointInNeighbour}] return offset added to exit point.
    \end{description}
d241 1
a241 1
                                % Slide 12
d248 1
a248 1
  \item Vanilla implementation of Glassner.
d253 1
a253 1
                                % Slide 13
d258 1
a258 1
  \item Comparison with Glassner's/Ajay Gupta's algorithms w\.r\.t\. memory
@


1.1
log
@Initial revision
@
text
@d1 262
@
